#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include "cons.h"

/*

	w lampi
	F mets
	f kevyt mets
	b puska
	p pelto
	s suo
	r joki
	d aavikko
	- meri
	^ vuori

*/

#define X 100
#define Y 60

static char Field[Y][X];
static int Totals[256];

inline char GetF(int x, int y)
{
	return Field[(y+Y)%Y][(x+X)%X]; /*
	if(y<0)return x<0 ? Field[0][0] : x>=X ? Field[0][X-1] : Field[0][x];
	if(y>=Y)return x<0 ? Field[Y-1][0] : x>=X ? Field[Y-1][X-1] : Field[Y-1][x];
	if(x<0)return Field[y][0];
	if(x>=X)return Field[y][X-1];
	return Field[y][x];*/
}
static void SetF(int x, int y, char what)
{
	Totals[(int)Field[y][x]]--;
	Totals[(int)what]++;
			
	Field[y][x] = what;
	
	if(x<120 && y<63)
	{
		GotoXY(1+x, 1+y);
		SetAttr(what=='w' ? 0x19
		      : what=='F' ? 0x20
		      : what=='f' ? 0x2A
		      : what=='b' ? 0x02
		      : what=='p' ? 0x0A
		      : what=='s' ? 0x26
		      : what=='r' ? 0x09
		      : what=='-' ? 0x01
		      : what=='d' ? 0x0E
		      : what=='^' ? 0x87
		      : 7);
		Gputchar(what);
	}
}
static int In(char what, const char *sel)
{
	const char *s = strchr(sel, what);
	return s && *s;
}
static int Around(int x, int y, const char *what, int level, int fails)
{
	int dx,dy, num=0;
		
	#define tsek() \
		if(In(GetF(x+dx,y+dy), what))++num; \
		else { if(!fails)return 0; --fails; }
		
	for(dy=-level; dy<=level; ++dy)
	{
		dx=-level; tsek(); dx=level; tsek();
	}
	for(dx=-level+1; dx<level-1; ++dx)
	{
		dy=-level; tsek(); dy=level; tsek();
	}
	
	#undef tsek

	return num;
}
static int Urgent(int x,int y, char what, char against)
{
	if(what != against && GetF(x,y)==against)
	{
		char Buf[2] = {0,0};
		char Buf2[2] = {0,0};
		int n;
		Buf[0] = what;
		Buf2[0] = against;
		if(!Around(x,y, Buf, 1, 7))return 1;
		n = Around(x,y, Buf2, 1, 8);
		if(n>5 || n==2
		|| Around(x,y, Buf2, 2, 16) > 6
		|| Around(x,y, Buf2, 3, 24) > 9
		)return 1;
	}	
	return 0;
}
static int Ok(int x, int y, char what)
{
	if(Urgent(x,y,what,'-')
	|| Urgent(x,y,what,'^'))return 0;
	
	switch(what)
	{
		/* 10 + 35 + 8 + 30 + 4 + 20 + 10 */
		case 'w':
			return Around(x,y, "fwbs", 1, 0)
			    && Totals['w'] < (X*Y * 8 / 100)
			    && !In(GetF(x,y), "br-");
		case '^':
			return Around(x,y, "^pfF", 1, 0)
			    && Totals['^'] < (X*Y * 12 / 100)
			    && !In(GetF(x,y), "wrs");
		case 'F':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "fFp-", 1, 0)
			    && Totals['F'] < (X*Y * 25 / 100)
			    && (Totals['F']+Totals['f']) < (X*Y * 35 / 100)
			    && !In(GetF(x,y), "dpr-");
		case 'f':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "fwFpbs-", 1, 0)
			    && Totals['f'] < (X*Y * 20 / 100)
			    && (Totals['F']+Totals['f']) < (X*Y * 35 / 100)
			    && !In(GetF(x,y), "dwr-");
		case 'b':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "fb", 1, 7)
			    && Around(x,y, "fpbw", 1, 0)
			    && Totals['b'] < (X*Y * 14 / 100)
			    && !In(GetF(x,y), "wr-");
		case 'p':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "bpfds-^", 1, 0)
/* 			    && Around(x,y, "p", 1, 7)
*/			    && Totals['p'] < (X*Y * 45 / 100)
			    /*&& !In(GetF(x,y), "")*/;
		case 's':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "wspf-", 1, 0)
			    && Totals['s'] < (X*Y * 4 / 100)
			    && !In(GetF(x,y), "f-");
		case '-':
			if(Around(x,y, "-", 1, 0))return 1;
			return Around(x,y, "dp-", 1, 0)
			    && Totals['-'] < (X*Y * 40 / 100)
			    && !In(GetF(x,y), "^");

/*
		case 'r':
			return Around(x,y, "rw", 1, 6)
			    && Around(x,y, "r", 2, 16) < 4
			    && Totals['r'] < (X*Y * 6 / 100);
*/
		case 'd':
			if(Around(x,y, "-", 1, 0))return 0;
			return Around(x,y, "dp-^f", 1, 0)
			    && Totals['d'] < (X*Y * 18 / 100)
			    && !In(GetF(x,y), "rf");
	}
	return 0;
}
static volatile int sign=0;
static void sigh(int s)
{
	s=s;
	sign=1;
}

extern int AllowINT=1;

int main(void)
{
	int x,y;
	InitCons();
	signal(SIGINT, sigh);
	for(y=0; y<Y; ++y)
		for(x=0; x<X; ++x)
			SetF(x,y, (x<X/11-y/3)?'-':'p');
			
	while(!sign)
	{
		const char *s = "fwdbFpsr-^";
		int sels;
		struct{char c; int score;}sel[8];
		
		x = rand()%X;
		y = rand()%Y;
		
/*		sels = rand()%strlen(s);
		if(Ok(x,y, s[sels]))
			SetF(x,y, s[sels]);
		continue;
*/		
		for(sels=0; *s; ++s)
			if(Field[y][x] != *s && Ok(x,y, *s))
			{
				static const char AM[9] = {1,2,3,4,6,7,6,5};
				sel[sels].c = *s;
				sel[sels].score = AM[(GetF(x-1,y-1)==*s)
					                + (GetF(x  ,y-1)==*s)
					                + (GetF(x+1,y-1)==*s)
					                + (GetF(x-1,y  )==*s)
					                + (GetF(x+1,y  )==*s)
					                + (GetF(x-1,y+1)==*s)
				    	            + (GetF(x  ,y+1)==*s)
				        	        + (GetF(x+1,y+1)==*s)] + rand()%3;
				++sels;
			}
		if(sels)
		{
			int sc=0, b=0, a;
			for(a=0; a<sels; ++a)
				if(sel[a].score > sc)
					sc = sel[b=a].score;
			
			SetF(x,y, sel[b].c);
		}
	}
	SetAttr(7);
	ClrScr();
	DoneCons();
	for(y=0; y<Y; ++y)
	{
		for(x=0; x<X; ++x)
			fprintf(stderr, "%c", Field[y][x]);
		fprintf(stderr, "\n");
	}
	return 0;
}
